#property strict

#include "Indicator.mqh"

class SIMPLE_EMA : public INDICATOR
{
private:
  double Alpha;
  int Pause;

public:
  void Init( const double dAlpha = 0, const double dPause = 0 )
  {
    this.Alpha = dAlpha;
    this.Pause = (int)dPause;

    return;
  }

  SIMPLE_EMA( const double dAlpha = 0, const double dPause = 0, const bool AddEvent = FALSE  ) : INDICATOR(AddEvent)
  {
    this.Init(dAlpha, dPause);

    const string Names[] = {"Simple_EMA"};
    const int Types[] = {DRAW_LINE};
    const color Colors[] = {clrRed};

    const int Size = ::ArraySize(Names);

    ::ArrayResize(this.Buffers, Size);

    for (int i = 0; i < Size; i++)
      this.Buffers[i] = new BUFFER(Types[i], EMPTY, EMPTY, Colors[i], Names[i], TRUE, TRUE); //       -   

    ::IndicatorSetInteger(INDICATOR_DIGITS, ::_Digits);

    ::EventSetMillisecondTimer(100); //     (  )
  }

  ~SIMPLE_EMA( void )
  {
    ::EventKillTimer();
  }

  virtual int Calculate( const int rates_total,
                         const int prev_calculated,
                         const datetime &time[],
                         const double &open[],
                         const double &high[],
                         const double &low[],
                         const double &close[],
                         const long &tick_volume[],
                         const long &volume[],
                         const int &spread[] )
  {
    for (int i = rates_total - prev_calculated - 1; i >= 0; i--)
      if (i == rates_total - 1)
        this.Buffers[0].Buffer[rates_total - 1] = open[rates_total - 1];
      else
        this.Buffers[0].Buffer[i] = this.Buffers[0].Buffer[i + 1] * (1 - this.Alpha) + open[i] * this.Alpha;

    //  ,    
    if (prev_calculated == 0)
      this.ToVisual(this.Pause);
    else
      this.ToVisual();

    return(rates_total);
  }
};